-- top level --
library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity BLINKLED is
	port (
		CLKIN	: in std_logic ;
		SWIN	: in std_logic ;
		LEDOUT0	: out	std_logic ;
		LEDOUT1	: out	std_logic
	) ;
end BLINKLED;

architecture RTL of BLINKLED is
component COUNTER
	port (
		CLK	: in std_logic ;
		RST	: in std_logic ;
		ENB	: in std_logic ;
		Q		: out std_logic_vector(31 downto 0)
	) ;
end component;

-- signal clkin : std_logic ;
signal cout  : std_logic_vector(31 downto 0) ;

begin
	LEDOUT0 <= SWIN;
	count0 : COUNTER port map(CLK=>CLKIN, RST=>'0', ENB=>SWIN, Q=>cout);
	LEDOUT1 <= cout(17);
end RTL;

-- 32bit counter --
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity COUNTER is
	port (
		CLK	: in std_logic ;
		RST	: in std_logic ;
		ENB	: in std_logic ;
		Q		: out std_logic_vector(31 downto 0)
	) ;
end COUNTER;

architecture RTL of COUNTER is
signal q_reg: std_logic_vector(31 downto 0);
begin
	Q <= q_reg;
	process( CLK ) begin
		if CLK'event and CLK='1' then
			if RST='1' then
				q_reg <= "00000000000000000000000000000000";
			elsif ENB='1' then
				q_reg <= q_reg + "1";
			else
				q_reg <= q_reg;
			end if;
		end if;
	end process;
end RTL;


	